import processing.video.*;

int letterCount = 26;
int currentLetter = 0;
float ratio = 0;

PImage bg;
PImage frame;
PImage png[] = new PImage[letterCount];
PImage jpg[] = new PImage[letterCount];
Capture cam;

float redDifference;
float greenDifference;
float blueDifference;

int whitePixels;
int pixelCount[] = new int[letterCount];

boolean showWebcam;

void setup()
{
  showWebcam = false;
  size(640,480);
  cam = new Capture(this, width, height, 30);
  frame = createImage(width,height,RGB);
  bg    = createImage(width,height,RGB);
  cam.start();
  
  png[0] = loadImage("a.png");
  jpg[0] = loadImage("a.jpg");
  
  png[1] = loadImage("b.png");
  jpg[1] = loadImage("b.jpg");

  png[2] = loadImage("c.png");
  jpg[2] = loadImage("c.jpg");

  png[3] = loadImage("d.png");
  jpg[3] = loadImage("d.jpg");

  png[4] = loadImage("e.png");
  jpg[4] = loadImage("e.jpg");

  png[5] = loadImage("f.png");
  jpg[5] = loadImage("f.jpg");

  png[6] = loadImage("g.png");
  jpg[6] = loadImage("g.jpg");

  png[7] = loadImage("h.png");
  jpg[7] = loadImage("h.jpg");

  png[8] = loadImage("i.png");
  jpg[8] = loadImage("i.jpg");

  png[9] = loadImage("j.png");
  jpg[9] = loadImage("j.jpg");

  png[10] = loadImage("k.png");
  jpg[10] = loadImage("k.jpg");

  png[11] = loadImage("l.png");
  jpg[11] = loadImage("l.jpg");

  png[12] = loadImage("m.png");
  jpg[12] = loadImage("m.jpg");

  png[13] = loadImage("n.png");
  jpg[13] = loadImage("n.jpg");
  
  png[14] = loadImage("o.png");
  jpg[14] = loadImage("o.jpg");

  png[15] = loadImage("p.png");
  jpg[15] = loadImage("p.jpg");

  png[16] = loadImage("q.png");
  jpg[16] = loadImage("q.jpg");

  png[17] = loadImage("r.png");
  jpg[17] = loadImage("r.jpg");

  png[18] = loadImage("s.png");
  jpg[18] = loadImage("s.jpg");

  png[19] = loadImage("t.png");
  jpg[19] = loadImage("t.jpg");

  png[20] = loadImage("u.png");
  jpg[20] = loadImage("u.jpg");

  png[21] = loadImage("v.png");
  jpg[21] = loadImage("v.jpg");

  png[22] = loadImage("w.png");
  jpg[22] = loadImage("w.jpg");

  png[23] = loadImage("x.png");
  jpg[23] = loadImage("x.jpg");

  png[24] = loadImage("y.png");
  jpg[24] = loadImage("y.jpg");

  png[25] = loadImage("z.png");
  jpg[25] = loadImage("z.jpg");

  for(int j = 0; j < letterCount; j++)
  {
    pixelCount[j] = 0;
    for(int i = 0; i<width*height; i++)
    {
      if(red(jpg[j].pixels[i])+blue(jpg[j].pixels[i])+green(jpg[j].pixels[i]) > 750)
         pixelCount[j]++;
    }
  }
  
}

void draw()
{
  whitePixels = 0;
  cam.read();
  for(int i = 0; i<width*height; i++)
  {
    redDifference =     red(cam.pixels[i])-   red(bg.pixels[i]);
    greenDifference = green(cam.pixels[i])- green(bg.pixels[i]);
    blueDifference =   blue(cam.pixels[i])-  blue(bg.pixels[i]);
    
    if(redDifference < 0)
       redDifference = -1*redDifference;
    if(greenDifference < 0)
       greenDifference = -1*redDifference;
    if(blueDifference < 0)
       blueDifference = -1*redDifference;
    
    if(redDifference < 20 && greenDifference < 20 && blueDifference < 20)
    {
      frame.pixels[i] = color(0);
    }
    else
    {
      frame.pixels[i] = color(255);
      if(red(jpg[currentLetter].pixels[i])+blue(jpg[currentLetter].pixels[i])+green(jpg[currentLetter].pixels[i]) > 750)
        whitePixels++;
    }
  }
  
  frame.updatePixels();
  
  if(showWebcam)
    image(cam,0,0);
  else
    image(frame,0,0);
  image(png[currentLetter],0,0);
  
  ratio = (1.0*whitePixels)/pixelCount[currentLetter];
  
  if(ratio > 0.7)
  {
    currentLetter = int(random(letterCount));
  }
  
  text(Float.toString(ratio), 30,30);
}

void keyPressed()
{
  if(key == ' ')
  {
     for(int i = 0; i<width*height; i++)
     {
        bg.pixels[i] = cam.pixels[i];
     }
  }
  else if(key == 'w')
  {
    showWebcam = !showWebcam;
  }
  else if(key == 'c')
  {
    currentLetter = int(random(letterCount));
  }
}
